LeetCode 363 - Max Sum of Rectangle No Larger Than K


https://leetcode.com/problems/max-sum-of-sub-matrix-no-larger-than-k/
Given a non-empty 2D matrix matrix and an integer k, find the max sum of a rectangle in the matrix such that its sum is no larger than k.
Example:
Given matrix = [
  [1,  0, 1],
  [0, -2, 3]
]
k = 2
The answer is 2. Because the sum of rectangle [[0, 1], [-2, 3]] is 2 and 2 is the max number no larger than k (k = 2).
Note:
  1. The rectangle inside the matrix must have an area > 0.
  2. What if the number of rows is much larger than the number of columns?
https://discuss.leetcode.com/topic/48875/accepted-c-codes-with-explanation-and-references
The naive solution is brute-force, which is O((mn)^2). In order to be more efficient, I tried something similar to Kadane's algorithm. The only difference is that here we have upper bound restriction K. Here's the easily understanding video link for the problem "find the max sum rectangle in 2D array": Maximum Sum Rectangular Submatrix in Matrix dynamic programming/2D kadane (Trust me, it's really easy and straightforward).
Once you are clear how to solve the above problem, the next step is to find the max sum no more than K in an array. This can be done within O(nlogn), and you can refer to this article: max subarray sum no more than k.
For the solution below, I assume that the number of rows is larger than the number of columns. Thus in general time complexity is O[min(m,n)^2 * max(m,n) * log(max(m,n))], space O(max(m, n)).
public int maxSumSubmatrix(int[][] matrix, int k) {
    //2D Kadane's algorithm + 1D maxSum problem with sum limit k
    //2D subarray sum solution
    
    //boundary check
    if(matrix.length == 0) return 0;
    
    int m = matrix.length, n = matrix[0].length;
    int result = Integer.MIN_VALUE;
    
    //outer loop should use smaller axis
    //now we assume we have more rows than cols, therefore outer loop will be based on cols 
    for(int left = 0; left < n; left++){
        //array that accumulate sums for each row from left to right 
        int[] sums = new int[m];
        for(int right = left; right < n; right++){
            //update sums[] to include values in curr right col
            for(int i = 0; i < m; i++){
                sums[i] += matrix[i][right];
            }
            
            //we use TreeSet to help us find the rectangle with maxSum <= k with O(logN) time
            TreeSet<Integer> set = new TreeSet<Integer>();
            //add 0 to cover the single row case
            set.add(0);
            int currSum = 0;
            
            for(int sum : sums){
                currSum += sum;
                //we use sum subtraction (curSum - sum) to get the subarray with sum <= k
                //therefore we need to look for the smallest sum >= currSum - k
                Integer num = set.ceiling(currSum - k);//\\
                if(num != null) result = Math.max( result, currSum - num );
                set.add(currSum);
            }
        }
    }
    
    return result;
}
https://discuss.leetcode.com/topic/48854/java-binary-search-solution-time-complexity-min-m-n-2-max-m-n-log-max-m-n
public int maxSumSubmatrix(int[][] matrix, int target) {
    int row = matrix.length;
    if(row==0)return 0;
    int col = matrix[0].length;
    int m = Math.min(row,col);
    int n = Math.max(row,col);
    //indicating sum up in every row or every column
    boolean colIsBig = col>row;
    int res = Integer.MIN_VALUE;
    for(int i = 0;i<m;i++){
        int[] array = new int[n];
        // sum from row j to row i
        for(int j = i;j>=0;j--){
            int val = 0;
            TreeSet<Integer> set = new TreeSet<Integer>();
            set.add(0);
            //traverse every column/row and sum up
            for(int k = 0;k<n;k++){
                array[k]=array[k]+(colIsBig?matrix[j][k]:matrix[k][j]);
                val = val + array[k];
                //use  TreeMap to binary search previous sum to get possible result 
                Integer subres = set.ceiling(val-target);//\\
                if(null!=subres){
                    res=Math.max(res,val-subres);
                }
                set.add(val);
            }
        }
    }
    return res;
}

http://bookshadow.com/weblog/2016/06/22/leetcode-max-sum-of-sub-matrix-no-larger-than-k/
题目可以通过降维转化为求解子问题:和不大于k的最大子数组,解法参考:https://www.quora.com/Given-an-array-of-integers-A-and-an-integer-k-find-a-subarray-that-contains-the-largest-sum-subject-to-a-constraint-that-the-sum-is-less-than-k
首先枚举列的起止范围x, y,子矩阵matrix[][x..y]可以通过部分和数组sums进行表示:
sums[i] = Σ(matrix[i][x..y])
接下来求解sums数组中和不大于k的最大子数组的和。
如果矩阵的列数远大于行数,则将枚举列变更为枚举行即可。
public int maxSumSubmatrix(int[][] matrix, int k) { int m = matrix.length, n = 0; if (m > 0) n = matrix[0].length; if (m * n == 0) return 0; int M = Math.max(m, n); int N = Math.min(m, n); int ans = Integer.MIN_VALUE; for (int x = 0; x < N; x++) { int sums[] = new int[M]; for (int y = x; y < N; y++) { TreeSet<Integer> set = new TreeSet<Integer>(); int num = 0; for (int z = 0; z < M; z++) { sums[z] += m > n ? matrix[z][y] : matrix[y][z]; num += sums[z]; if (num <= k) ans = Math.max(ans, num); Integer i = set.ceiling(num - k); if (i != null) ans = Math.max(ans, num - i); set.add(num); } } } return ans; }
https://www.hrwhisper.me/leetcode-max-sum-rectangle-no-larger-k/
朴素的思想为,枚举起始行,枚举结束行,枚举起始列,枚举终止列。。。。。O(m^2 * n^2)
这里用到一个技巧就是,进行求和时,我们可以把二维的合并成一维,然后就变为求一维的解。
比如对于矩阵:
[1, 0, 1],
[0, -2, 3]
进行起始行为0,终止行为1时,可以进行列的求和,即[1, -2, 3]中不超过k的最大值。
求和的问题解决完,还有一个是不超过k. 这里我参考了 https://leetcode.com/discuss/109705/java-binary-search-solution-time-complexity-min-max-log-max 的方法
使用了二分搜索。对于当前的和为sum,我们只需要找到一个最小的数x,使得 sum – k <=x,这样可以保证sum – x <=k。
这里需要注意,当行远大于列的时候怎么办呢?转换成列的枚举 即可。
在代码实现上,我们只需要让 m 永远小于 n即可。这样复杂度总是为O(m^2*n*log n)
int maxSumSubmatrix(vector<vector<int>>& matrix, int k) {
if (matrix.empty()) return 0;
int ans = INT_MIN,m = matrix.size(), n = matrix[0].size(),row_first=true;
if (m > n) {
swap(m, n);
row_first = false;
}
for (int ri = 0; ri < m; ri++) {
vector<int> temp(n, 0);
for (int i = ri; i >= 0; i--) {
set<int> sums;
int sum = 0;
sums.insert(sum);
for (int j = 0; j < n; j++) {
temp[j] += row_first ? matrix[i][j]: matrix[j][i];
sum += temp[j];
auto it = sums.lower_bound(sum - k);
if (it != sums.end())
ans = max(ans, sum - *it);
sums.insert(sum);
}
}
}
return ans;
}
https://leetcode.com/discuss/109705/java-binary-search-solution-time-complexity-min-max-log-max
/* first consider the situation matrix is 1D we can save every sum of 0~i(0<=i<len) and binary search previous sum to find possible result for every index, time complexity is O(NlogN). so in 2D matrix, we can sum up all values from row i to row j and create a 1D array to use 1D array solution. If col number is less than row number, we can sum up all values from col i to col j then use 1D array solution. */ public int maxSumSubmatrix(int[][] matrix, int target) { int row = matrix.length; if(row==0)return 0; int col = matrix[0].length; int m = Math.min(row,col); int n = Math.max(row,col); //indicating sum up in every row or every column boolean colIsBig = col>row; int res = Integer.MIN_VALUE; for(int i = 0;i<m;i++){ int[] array = new int[n]; // sum from row j to row i for(int j = i;j>=0;j--){ int val = 0; TreeSet<Integer> set = new TreeSet<Integer>(); set.add(0); //traverse every column/row and sum up for(int k = 0;k<n;k++){ array[k]=array[k]+(colIsBig?matrix[j][k]:matrix[k][j]); val = val + array[k]; //use TreeMap to binary search previous sum to get possible result Integer subres = set.ceiling(val-target); if(null!=subres){ res=Math.max(res,val-subres); } set.add(val); } } } return res; }
Thank you for your great answer! Can you explain why you need to set.add(0) ?? even though s(j) (j < i) may not necessarily contains 0?
Because the result can start from index 0. e.g. [1,1,5] k=3 solution is 1+1=2. So 0 in set means no need to subtract previous sum.
There is a simple version of O(n^4). The idea is to calculate every rectangle [[r1,c1], [r2,c2]], and simply pick the max area <= k. An improved version takes O(n^3logn). It borrows the idea to find max subarray with sum <= k in 1D array, and apply here: we find all rectangles bounded between r1 & r2, with columns from 0 to end. Pick a pair from tree. I remember the interviewer said there could be an even better solution, but I haven't figured that out...
public int maxSumSubmatrix(int[][] matrix, int k) { if (matrix == null || matrix.length == 0 || matrix[0].length == 0) return 0; int rows = matrix.length, cols = matrix[0].length; int[][] areas = new int[rows][cols]; for (int r = 0; r < rows; r++) { for (int c = 0; c < cols; c++) { int area = matrix[r][c]; if (r-1 >= 0) area += areas[r-1][c]; if (c-1 >= 0) area += areas[r][c-1]; if (r-1 >= 0 && c-1 >= 0) area -= areas[r-1][c-1]; areas[r][c] = area; } } int max = Integer.MIN_VALUE; for (int r1 = 0; r1 < rows; r1++) { for (int c1 = 0; c1 < cols; c1++) { for (int r2 = r1; r2 < rows; r2++) { for (int c2 = c1; c2 < cols; c2++) { int area = areas[r2][c2]; if (r1-1 >= 0) area -= areas[r1-1][c2]; if (c1-1 >= 0) area -= areas[r2][c1-1]; if (r1-1 >= 0 && c1 -1 >= 0) area += areas[r1-1][c1-1]; if (area <= k) max = Math.max(max, area); } } } } return max; }
Solution II (O(n^3logn)
public int maxSumSubmatrix(int[][] matrix, int k) { if (matrix == null || matrix.length == 0 || matrix[0].length == 0) return 0; int rows = matrix.length, cols = matrix[0].length; int[][] areas = new int[rows][cols]; for (int r = 0; r < rows; r++) { for (int c = 0; c < cols; c++) { int area = matrix[r][c]; if (r-1 >= 0) area += areas[r-1][c]; if (c-1 >= 0) area += areas[r][c-1]; if (r-1 >= 0 && c-1 >= 0) area -= areas[r-1][c-1]; areas[r][c] = area; } } int max = Integer.MIN_VALUE; for (int r1 = 0; r1 < rows; r1++) { for (int r2 = r1; r2 < rows; r2++) { TreeSet<Integer> tree = new TreeSet<>(); tree.add(0); // padding for (int c = 0; c < cols; c++) { int area = areas[r2][c]; if (r1-1 >= 0) area -= areas[r1-1][c]; Integer ceiling = tree.ceiling(area - k); if (ceiling != null) max = Math.max(max, area - ceiling); tree.add(area); } } } return max; }

https://reeestart.wordpress.com/2016/06/24/google-largest-matrix-less-than-target/
这题和Maximum Sub Matrix差不多,只不过Less than target的条件使得Kadane’s Algorithm不再适用于这道题。需要将maximum subarray改成maximum subarray less than target.
正确的方法要借助cumulative sum,
sums[j] – sums[i] <= k
sums[j] <= k + sums[i]
所以,遍历sums[]数组,对于每个sums[i],在[i+1, n-1]里面找 满足小于等于k + sums[i]中最大的。找得到就更新result,找不到就不更新。
那么问题来了,怎么找小于等于k + sums[i]中最大的?
答曰:Binary Search!
然后我就对着我的binary search code debug了快4个小时,当知道真相的那一刻眼泪都要掉下来了。
谁他妈说过cumulative sum一定是递增的?
那么问题又来了,一个个找要O(n^2) time,还有别的方法么?
“满足小于等于k + sums[i]中最大的”  ==  floor(k + sums[i])
看到floor想到什么?
Red-Black Tree啊!TreeSet啊!TreeMap啊!Balanced Binary Search Tree啊!
[Time & Space]
由于Maximum subarray less than Target需要O(nlogn) time,所以总的时间为O(n^3 * logn)

  public int maxSumSubmatrix(int[][] matrix, int k) {
    if (matrix == null || matrix.length == 0) {
      return 0;
    }
    int m = matrix.length;
    int n = matrix[0].length;
    int result = Integer.MIN_VALUE;
    for (int i = 0; i < n; i++) {
      int r = i;
      int[] local = new int[m];
      while (r < n) {
        for (int x = 0; x < m; x++) {
          local[x] += matrix[x][r];
        }
        int localResult = maxSubArray(local, k);
        result = Math.max(result, localResult);
        r++;
      }
    }
    return result;
  }
  // maximum subarray less than k
  // can not use two pointer, [2, -7, 6, -1], k = 0
  // TreeSet, find ceiling, O(nlogn)
  private int maxSubArray(int[] nums, int k) {
    int result = Integer.MIN_VALUE;
    TreeSet<Integer> tSet = new TreeSet<>();
    int[] sums = new int[nums.length];
    sums[0] = nums[0];
    tSet.add(sums[0]);
    if (sums[0] <= k) {
      result = Math.max(result, sums[0]);
    }
    for (int i = 1; i < nums.length; i++) {
      sums[i] = sums[i - 1] + nums[i];
      if (sums[i] <= k) {
        result = Math.max(result, sums[i]);
      }
      Integer ceil = tSet.ceiling(sums[i] - k);
      if (ceil != null) {
        result = Math.max(result, sums[i] - ceil);
      }
      tSet.add(sums[i]);
    }
    return result;
  }
  // TreeSet find floor
  private int maxSubArray2(int[] nums, int k) {
    int n = nums.length;
    int result = Integer.MIN_VALUE;
    TreeSet<Integer> tSet = new TreeSet<>();
    int[] sums = new int[n];
    int sum = 0;
    for (int i = 0; i < n; i++) {
      sum += nums[i];
    }
    for (int i = n - 1; i >= 0; i--) {
      sums[i] = sum;
      if (sums[i] <= k) {
        result = Math.max(result, sums[i]);
      }
      if (i != n - 1) {
        Integer floor = tSet.floor(sums[i] + k);
        if (floor != null) {
          result = Math.max(result, floor - sums[i]);
        }
      }
      sum -= nums[i];
      tSet.add(sums[i]);
    }
    return result;
  }
X. Merge sort
https://discuss.leetcode.com/topic/53939/java-117ms-beat-99-81-merge-sort

 * If # of columns is smaller, process one set of columns [i..j) at a time, for each different i<j.
 * For one set of colums [i..j), do it like "Count of Range Sum".
 * O(n) = n^2 * mlogm.
 * Assume we have such result.
    public int maxSumSubmatrix(int[][] matrix, int k) {
        int m = matrix.length, n = matrix[0].length, ans = Integer.MIN_VALUE;
        long[] sum = new long[m+1]; // stores sum of rect[0..p][i..j]
        for (int i = 0; i < n; ++i) {
            long[] sumInRow = new long[m];
            for (int j = i; j < n; ++j) { // for each rect[*][i..j]
                for (int p = 0; p < m; ++p) {
                    sumInRow[p] += matrix[p][j];
                    sum[p+1] = sum[p] + sumInRow[p];
                }
                ans = Math.max(ans, mergeSort(sum, 0, m+1, k));
                if (ans == k) return k;
            }
        }
        return ans;
    }
    int mergeSort(long[] sum, int start, int end, int k) {
        if (end == start+1) return Integer.MIN_VALUE; // need at least 2 to proceed
        int mid = start + (end - start)/2, cnt = 0;
        int ans = mergeSort(sum, start, mid, k);
        if (ans == k) return k;
        ans = Math.max(ans, mergeSort(sum, mid, end, k));
        if (ans == k) return k;
        long[] cache = new long[end-start];
        for (int i = start, j = mid, p = mid; i < mid; ++i) {
            while (j < end && sum[j] - sum[i] <= k) ++j;
            if (j-1 >= mid) {
                ans = Math.max(ans, (int)(sum[j-1] - sum[i]));
                if (ans == k) return k;
            }
            while (p < end && sum[p] < sum[i]) cache[cnt++] = sum[p++];
            cache[cnt++] = sum[i];
        }
        System.arraycopy(cache, 0, sum, start, cnt);
        return ans;
    }

X. Brute Force
https://discuss.leetcode.com/topic/48923/2-accepted-java-solution
https://discuss.leetcode.com/topic/49083/naive-but-accepted-java-solution
There is a simple version of O(n^4).
The idea is to calculate every rectangle [[r1,c1], [r2,c2]], and simply pick the max area <= k.
An improved version takes O(n^3logn). It borrows the idea to find max subarray with sum <= k in 1D array, and apply here: we find all rectangles bounded between r1 & r2, with columns from 0 to end. Pick a pair from tree.
public int maxSumSubmatrix(int[][] matrix, int k) {
    if (matrix == null || matrix.length == 0 || matrix[0].length == 0)
        return 0;
    int rows = matrix.length, cols = matrix[0].length;
    int[][] areas = new int[rows][cols];
    for (int r = 0; r < rows; r++) {
        for (int c = 0; c < cols; c++) {
            int area = matrix[r][c];
            if (r-1 >= 0)
                area += areas[r-1][c];
            if (c-1 >= 0)
                area += areas[r][c-1];
            if (r-1 >= 0 && c-1 >= 0)
                area -= areas[r-1][c-1];
            areas[r][c] = area;
        }
    }
    int max = Integer.MIN_VALUE;
    for (int r1 = 0; r1 < rows; r1++) {
        for (int c1 = 0; c1 < cols; c1++) {
            for (int r2 = r1; r2 < rows; r2++) {
                for (int c2 = c1; c2 < cols; c2++) {
                    int area = areas[r2][c2];
                    if (r1-1 >= 0)
                        area -= areas[r1-1][c2];
                    if (c1-1 >= 0)
                        area -= areas[r2][c1-1];
                    if (r1-1 >= 0 && c1 -1 >= 0)
                        area += areas[r1-1][c1-1];
                    if (area <= k)
                        max = Math.max(max, area);
                }
            }
        }
    }
    return max;
}



Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts